/* ========================================
 *
 * Copyright YOUR COMPANY, THE YEAR
 * All Rights Reserved
 * UNPUBLISHED, LICENSED SOFTWARE.
 *
 * CONFIDENTIAL AND PROPRIETARY INFORMATION
 * WHICH IS THE PROPERTY OF your company.
 *
 * ========================================
*/

#define FALSE   0
#define TRUE    !FALSE
#define forever TRUE
#define LEDOn  	1
#define LEDOff	0					//	LEDs are active high on a CY8CKIT-059
#define	forever	TRUE
#define Wait(x)						//	Just for readability


#include "project.h"
volatile int8 test=0;				//	Indicator for interrupt

CY_ISR_PROTO(MyHandler);			//	Only a forward definition

void InitializeSystem(void)
{
    isr_1_StartEx(MyHandler);		//	Start my own interrupt handler
      
    CyGlobalIntEnable; /* Enable global interrupts. */
	
    Pin_2_Write(LEDOn);						//	Blink blue LED once
	CyDelay(500);
	Pin_2_Write(LEDOff);

	
}

int main(void)
{
    
	InitializeSystem();
   
    
    while(forever)
    {
        
        while(!test) Wait();				//  Wait until pin goes high and low agai
        Pin_2_Write(LEDOn);						//	
		CyDelay(500);
		Pin_2_Write(LEDOff);
		test = 0;
    }
}

CY_ISR(MyHandler)				// This is the interrupt handler
{
	test = 1;
	Pin_1_ClearInterrupt();		//	Remove the interrupt in the pin component
	isr_1_ClearPending();		//	and any ints in the isr_1
}


/* [] END OF FILE */
